Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 2715)
@@ -32,9 +32,4 @@
 
    PUBLIC  p4z_bio    
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &  !:
-      xnegtr            ! Array used to indicate negative tracer values
-
 
    !!* Substitution
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 2715)
@@ -4,8 +4,8 @@
    !! TOP :   PISCES Sea water chemistry computed following OCMIP protocol
    !!======================================================================
-   !! History :    -   !  1988     (E. Maier-Reimer)  Original code
+   !! History :   OPA  !  1988     (E. Maier-Reimer)  Original code
    !!              -   !  1998     (O. Aumont)  addition
    !!              -   !  1999     (C. Le Quere)  modification
-   !!             1.0  !  2004     (O. Aumont)  modification
+   !!   NEMO      1.0  !  2004     (O. Aumont)  modification
    !!              -   !  2006     (R. Gangsto)  modification
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
@@ -15,61 +15,52 @@
    !!   'key_pisces'                                       PISCES bio-model
    !!----------------------------------------------------------------------
-   !!   p4z_che        :  Sea water chemistry computed following OCMIP protocol
-   !!----------------------------------------------------------------------
-   USE oce_trc         !
-   USE trc         !
-   USE sms_pisces      ! 
+   !!   p4z_che      :  Sea water chemistry computed following OCMIP protocol
+   !!----------------------------------------------------------------------
+   USE oce_trc       !
+   USE trc           !
+   USE sms_pisces    ! 
+   USE lib_mpp       ! MPP library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   p4z_che  
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      sio3eq, fekeq           !: chemistry of Fe and Si
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,2)   ::   &   !:
-      chemc                   !: Solubilities of O2 and CO2
-
-   !! * Module variables
-
-   REAL(wp) :: &
-      salchl = 1./1.80655 ! conversion factor for salinity --> chlorinity (Wooster et al. 1969)
-
-   REAL(wp) :: &            ! coeff. for apparent solubility equilibrium 
-      akcc1 = -171.9065 , &    ! Millero et al. 1995 from Mucci 1983
-      akcc2 = -0.077993 , &  
-      akcc3 = 2839.319  , &  
-      akcc4 = 71.595    , &  
-      akcc5 = -0.77712  , &  
-      akcc6 = 0.0028426 , &  
-      akcc7 = 178.34    , &  
-      akcc8 = -0.07711  , &  
-      akcc9 = 0.0041249
-
-   REAL(wp) :: &             ! universal gas constants
-      rgas = 83.143, &
-      oxyco = 1./22.4144
-
-   REAL(wp) :: &             ! borat constants
-      bor1 = 0.00023, &
-      bor2 = 1./10.82
-
-   REAL(wp) :: &              !
-      ca0 = -162.8301  , &
-      ca1 = 218.2968   , &
-      ca2 = 90.9241    , &
-      ca3 = -1.47696   , &
-      ca4 = 0.025695   , &
-      ca5 = -0.025225  , &
-      ca6 = 0.0049867
-
-   REAL(wp) :: &              ! coeff. for 1. dissoc. of carbonic acid (Edmond and Gieskes, 1970)   
-      c10 = -3670.7   , &
-      c11 = 62.008    , &
-      c12 = -9.7944   , &
-      c13 = 0.0118    , &
-      c14 = -0.000116
+   PUBLIC   p4z_che         !
+   PUBLIC   p4z_che_alloc   !
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sio3eq   ! chemistry of Si
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   fekeq    ! chemistry of Fe
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   chemc    ! Solubilities of O2 and CO2
+
+   REAL(wp) ::   salchl = 1._wp / 1.80655_wp ! conversion factor for salinity --> chlorinity (Wooster et al. 1969)
+
+   REAL(wp) ::   akcc1 = -171.9065_wp      ! coeff. for apparent solubility equilibrium
+   REAL(wp) ::   akcc2 =   -0.077993_wp    ! Millero et al. 1995 from Mucci 1983
+   REAL(wp) ::   akcc3 = 2839.319_wp       !
+   REAL(wp) ::   akcc4 =   71.595_wp       !
+   REAL(wp) ::   akcc5 =   -0.77712_wp     !
+   REAL(wp) ::   akcc6 =    0.0028426_wp   !
+   REAL(wp) ::   akcc7 =  178.34_wp        !
+   REAL(wp) ::   akcc8 =   -0.07711_wp     !
+   REAL(wp) ::   akcc9 =    0.0041249_wp   !
+
+   REAL(wp) ::   rgas  = 83.143_wp         ! universal gas constants
+   REAL(wp) ::   oxyco = 1._wp / 22.4144_wp
+
+   REAL(wp) ::   bor1 = 0.00023_wp         ! borat constants
+   REAL(wp) ::   bor2 = 1._wp / 10.82_wp
+
+   REAL(wp) ::   ca0 = -162.8301_wp
+   REAL(wp) ::   ca1 =  218.2968_wp
+   REAL(wp) ::   ca2 =   90.9241_wp
+   REAL(wp) ::   ca3 =   -1.47696_wp
+   REAL(wp) ::   ca4 =    0.025695_wp
+   REAL(wp) ::   ca5 =   -0.025225_wp
+   REAL(wp) ::   ca6 =    0.0049867_wp
+
+   REAL(wp) ::   c10 = -3670.7_wp        ! coeff. for 1. dissoc. of carbonic acid (Edmond and Gieskes, 1970)   
+   REAL(wp) ::   c11 =    62.008_wp     
+   REAL(wp) ::   c12 =    -9.7944_wp    
+   REAL(wp) ::   c13 =     0.0118_wp     
+   REAL(wp) ::   c14 =    -0.000116_wp
 
    REAL(wp) :: &              ! coeff. for 2. dissoc. of carbonic acid (Millero, 1995)   
@@ -133,5 +124,5 @@
       ox2 = 23.8439    , &
       ox3 = -0.034892  , &
-      ox4 = 0.015568   , &
+      ox4 =  0.015568  , &
       ox5 = -0.0019387 
 
@@ -151,7 +142,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -179,5 +169,4 @@
 !CDIR NOVERRCHK
          DO ji = 1, jpi
-
             !                             ! SET ABSOLUTE TEMPERATURE
             ztkel = tsn(ji,jj,1,jp_tem) + 273.16
@@ -324,4 +313,15 @@
    END SUBROUTINE p4z_che
 
+
+   INTEGER FUNCTION p4z_che_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_che_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( sio3eq(jpi,jpj,jpk) , fekeq(jpi,jpj,jpk) , chemc (jpi,jpj,2), STAT=p4z_che_alloc )
+      !
+      IF( p4z_che_alloc /= 0 )   CALL ctl_warn('p4z_che_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION p4z_che_alloc
+
 #else
    !!======================================================================
@@ -330,5 +330,5 @@
 CONTAINS
    SUBROUTINE p4z_che( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
+      INTEGER, INTENT(in) ::   kt
       WRITE(*,*) 'p4z_che: You should not have seen this print! error?', kt
    END SUBROUTINE p4z_che
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 2715)
@@ -27,6 +27,4 @@
    USE sbc_oce , ONLY :  atm_co2
 #endif
-   USE lib_mpp
-   USE lib_fortran
 
    IMPLICIT NONE
@@ -35,13 +33,15 @@
    PUBLIC   p4z_flx  
    PUBLIC   p4z_flx_init  
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  oce_co2            !: ocean carbon flux 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  satmco2            !: atmospheric pco2
-   REAL(wp)                             ::  t_oce_co2_flx      !: Total ocean carbon flux 
-   REAL(wp)                             ::  t_atm_co2_flx      !: global mean of atmospheric pco2
-   REAL(wp)                             ::  area               !: ocean surface
-   REAL(wp)                             ::  atcco2 = 278.      !: pre-industrial atmospheric [co2] (ppm) 	
-   REAL(wp)                             ::  atcox  = 0.20946   !:
-   REAL(wp)                             ::  xconv  = 0.01/3600 !: coefficients for conversion 
+   PUBLIC   p4z_flx_alloc  
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: oce_co2   !: ocean carbon flux 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: satmco2   !: atmospheric pco2 
+
+   REAL(wp) ::  t_oce_co2_flx               !: Total ocean carbon flux 
+   REAL(wp) ::  t_atm_co2_flx               !: global mean of atmospheric pco2
+   REAL(wp) ::  area                        !: ocean surface
+   REAL(wp) ::  atcco2 = 278._wp            !: pre-industrial atmospheric [co2] (ppm) 	
+   REAL(wp) ::  atcox  = 0.20946_wp         !:
+   REAL(wp) ::  xconv  = 0.01_wp / 3600._wp !: coefficients for conversion 
 
    !!* Substitution
@@ -50,7 +50,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -63,16 +62,21 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) :: kt
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zkgco2 => wrk_2d_1 , zkgo2 => wrk_2d_2 , zh2co3 => wrk_2d_3 
+      USE wrk_nemo, ONLY:   zoflx  => wrk_2d_4 , zkg   => wrk_2d_5
+      USE wrk_nemo, ONLY:   zdpco2 => wrk_2d_6 , zdpo2 => wrk_2d_7
+      !
+      INTEGER, INTENT(in) ::   kt   !
+      !
       INTEGER  ::   ji, jj, jrorr
       REAL(wp) ::   ztc, ztc2, ztc3, zws, zkgwan
       REAL(wp) ::   zfld, zflu, zfld16, zflu16, zfact
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zsch_o2, zalka, zsch_co2
-      REAL(wp), DIMENSION(jpi,jpj) ::   zkgco2, zkgo2, zh2co3
-#if defined key_diatrc && defined key_iomput
-      REAL(wp), DIMENSION(jpi,jpj) ::  zoflx, zkg, zdpco2, zdpo2
-#endif
       CHARACTER (len=25) :: charout
-
       !!---------------------------------------------------------------------
+
+      IF( wrk_in_use(2, 1,2,3,4,5,6,7) ) THEN
+         CALL ctl_stop('p4z_flx: requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
 
       ! SURFACE CHEMISTRY (PCO2 AND [H+] IN
@@ -149,6 +153,5 @@
             zfld = satmco2(ji,jj) * tmask(ji,jj,1) * chemc(ji,jj,1) * zkgco2(ji,jj)
             zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)
-            oce_co2(ji,jj) = ( zfld - zflu ) * rfact &
-               &             * e1t(ji,jj) * e2t(ji,jj) * tmask(ji,jj,1) * 1000.
+            oce_co2(ji,jj) = ( zfld - zflu ) * rfact * e1e2t(ji,jj) * tmask(ji,jj,1) * 1000.
             ! compute the trend
             tra(ji,jj,1,jpdic) = tra(ji,jj,1,jpdic) + ( zfld - zflu ) / fse3t(ji,jj,1)
@@ -162,5 +165,5 @@
             ! Save diagnostics
 #  if ! defined key_iomput
-            zfact = 1. / ( e1t(ji,jj) * e2t(ji,jj) ) / rfact
+            zfact = 1. / e1e2t(ji,jj) / rfact
             trc2d(ji,jj,jp_pcs0_2d    ) = oce_co2(ji,jj) * zfact
             trc2d(ji,jj,jp_pcs0_2d + 1) = ( zfld16 - zflu16 ) * 1000. * tmask(ji,jj,1)
@@ -180,5 +183,5 @@
       t_oce_co2_flx = t_oce_co2_flx + glob_sum( oce_co2(:,:) )                     ! Cumulative Total Flux of Carbon
       IF( kt == nitend ) THEN
-         t_atm_co2_flx = glob_sum( satmco2(:,:) * e1t(:,:) * e2t(:,:) )            ! Total atmospheric pCO2
+         t_atm_co2_flx = glob_sum( satmco2(:,:) * e1e2t(:,:) )            ! Total atmospheric pCO2
          !
          t_oce_co2_flx = (-1.) * t_oce_co2_flx  * 12. / 1.e15                      ! Conversion in PgC ; negative for out of the ocean
@@ -203,5 +206,5 @@
 
 # if defined key_diatrc && defined key_iomput
-      CALL iom_put( "Cflx" , oce_co2(:,:) / ( e1t(:,:) * e2t(:,:) ) / rfact  )
+      CALL iom_put( "Cflx" , oce_co2(:,:) / e1e2t(:,:) / rfact ) 
       CALL iom_put( "Oflx" , zoflx  )
       CALL iom_put( "Kg"   , zkg    )
@@ -209,9 +212,11 @@
       CALL iom_put( "Dpo2" , zdpo2  )
 #endif
-
+      !
+      IF( wrk_not_released(2, 1,2,3,4,5,6,7) )   CALL ctl_stop('p4z_flx: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_flx
 
+
    SUBROUTINE p4z_flx_init
-
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE p4z_flx_init  ***
@@ -222,12 +227,11 @@
       !!      called at the first timestep (nit000)
       !! ** input   :   Namelist nampisext
-      !!
-      !!----------------------------------------------------------------------
-
+      !!----------------------------------------------------------------------
       NAMELIST/nampisext/ atcco2
-
+      !!----------------------------------------------------------------------
+      !
       REWIND( numnat )                     ! read numnat
       READ  ( numnat, nampisext )
-
+      !
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' '
@@ -236,16 +240,25 @@
          WRITE(numout,*) '    Atmospheric pCO2      atcco2      =', atcco2
       ENDIF
-
-      ! interior global domain surface
-      area = glob_sum( e1t(:,:) * e2t(:,:) )  
-
-      ! Initialization of Flux of Carbon
-      oce_co2(:,:)  = 0._wp
+      !
+      area = glob_sum( e1e2t(:,:) )        ! interior global domain surface
+      !
+      oce_co2(:,:)  = 0._wp                ! Initialization of Flux of Carbon
       t_atm_co2_flx = 0._wp
-      ! Initialisation of atmospheric pco2
-      satmco2(:,:)  = atcco2
+      !
+      satmco2(:,:)  = atcco2      ! Initialisation of atmospheric pco2
       t_oce_co2_flx = 0._wp
-
+      !
    END SUBROUTINE p4z_flx_init
+
+
+   INTEGER FUNCTION p4z_flx_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_flx_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( oce_co2(jpi,jpj), satmco2(jpi,jpj), STAT=p4z_flx_alloc )
+      !
+      IF( p4z_flx_alloc /= 0 )   CALL ctl_warn('p4z_flx_alloc : failed to allocate arrays')
+      !
+   END FUNCTION p4z_flx_alloc
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 2715)
@@ -21,20 +21,16 @@
 
    PUBLIC   p4z_int  
+   PUBLIC   p4z_int_alloc
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      tgfunc,            &  !:  Temp. dependancy of various biological rates
-      tgfunc2               !:  Temp. dependancy of mesozooplankton rates 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc    !: Temp. dependancy of various biological rates
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc2   !: Temp. dependancy of mesozooplankton rates
 
-   !! * Module variables
-   REAL(wp) :: &
-      xksilim = 16.5E-6        ! Half-saturation constant for the computation of the Si half-saturation constant
-
+   REAL(wp) ::   xksilim = 16.5e-6_wp   ! Half-saturation constant for the Si half-saturation constant computation
 
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -47,5 +43,4 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      !!
       INTEGER  ::   ji, jj
       REAL(wp) ::   zdum
@@ -54,5 +49,4 @@
       ! Computation of phyto and zoo metabolic rate
       ! -------------------------------------------
-
       tgfunc (:,:,:) = EXP( 0.063913 * tsn(:,:,:,jp_tem) )
       tgfunc2(:,:,:) = EXP( 0.07608  * tsn(:,:,:,jp_tem) )
@@ -61,5 +55,4 @@
       ! constant for silica uptake
       ! ---------------------------------------------------
-
       DO ji = 1, jpi
          DO jj = 1, jpj
@@ -68,11 +61,22 @@
          END DO
       END DO
-
+      !
       IF( nday_year == nyear_len(1) ) THEN
          xksi    = xksimax
-         xksimax = 0.e0
+         xksimax = 0._wp
       ENDIF
       !
    END SUBROUTINE p4z_int
+
+
+   INTEGER FUNCTION p4z_int_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_int_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( tgfunc(jpi,jpj,jpk), tgfunc2(jpi,jpj,jpk), STAT=p4z_int_alloc )
+      !
+      IF( p4z_int_alloc /= 0 )   CALL ctl_warn('p4z_int_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION p4z_int_alloc
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2715)
@@ -31,14 +31,11 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-     kdca = 0.327e3_wp   ,  &  !:
-     nca  = 1.0_wp             !:
+   REAL(wp), PUBLIC :: kdca = 0.327e3_wp  !: diss. rate constant calcite
+   REAL(wp), PUBLIC :: nca  = 1.0_wp      !: order of reaction for calcite dissolution
 
    !! * Module variables
-   REAL(wp) :: &
-      calcon = 1.03E-2        ! mean calcite concentration [Ca2+] in sea water [mole/kg solution]
-
-   INTEGER ::               &
-     rmtss                    !: number of seconds per month
+   REAL(wp) :: calcon = 1.03E-2           !: mean calcite concentration [Ca2+] in sea water [mole/kg solution]
+ 
+   INTEGER  :: rmtss                      !: number of seconds per month 
 
    !!----------------------------------------------------------------------
@@ -60,4 +57,7 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zco3 => wrk_3d_2, zcaldiss => wrk_3d_3 
+      !
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk, jn
@@ -65,14 +65,15 @@
       REAL(wp) ::   zdispot, zfact, zalka
       REAL(wp) ::   zomegaca, zexcess, zexcess0
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zco3
 #if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zcaldiss
 #endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
+      IF(  wrk_in_use(3, 2,3) ) THEN
+         CALL ctl_stop('p4z_lys: requested workspace arrays unavailable')  ;  RETURN
+      END IF
+
       zco3(:,:,:) = 0.
-
 # if defined key_diatrc && defined key_iomput
       zcaldiss(:,:,:) = 0.
@@ -186,4 +187,6 @@
        ENDIF
 
+      IF( wrk_not_released(3, 2,3) ) CALL ctl_stop('p4z_lys: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_lys
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2715)
@@ -6,5 +6,5 @@
    !! History :   1.0  !  2004     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
-   !!             3.2  !  2009-04  (C. Ethe, G. Madec)  optimisaion
+   !!             3.2  !  2009-04  (C. Ethe, G. Madec)  optimisation
    !!----------------------------------------------------------------------
 #if defined  key_pisces
@@ -24,12 +24,13 @@
    PUBLIC   p4z_opt        ! called in p4zbio.F90 module
    PUBLIC   p4z_opt_init   ! called in trcsms_pisces.F90 module
-
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   etot, enano, ediat   !: PAR for phyto, nano and diat 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   emoy                 !: averaged PAR in the mixed layer
-
-   INTEGER  ::  nksrp   ! levels below which the light cannot penetrate ( depth larger than 391 m)
-   REAL(wp) ::  parlux = 0.43 / 3.e0
-
-   REAL(wp), DIMENSION(3,61), PUBLIC ::   xkrgb  !: tabulated attenuation coefficients for RGB absorption
+   PUBLIC   p4z_opt_alloc
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: etot, enano, ediat   !: PAR for phyto, nano and diat 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: emoy                 !: averaged PAR in the mixed layer
+
+   INTEGER  ::   nksrp   ! levels below which the light cannot penetrate ( depth larger than 391 m)
+   REAL(wp) ::   parlux = 0.43_wp / 3._wp
+
+   REAL(wp), DIMENSION(3,61), PUBLIC ::   xkrgb   !: tabulated attenuation coefficients for RGB absorption
    
    !!* Substitution
@@ -38,7 +39,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -52,20 +52,27 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zdepmoy => wrk_2d_1 , zetmp => wrk_2d_2
+      USE wrk_nemo, ONLY:   zekg    => wrk_3d_2 , zekr  => wrk_3d_3 , zekb => wrk_3d_4
+      USE wrk_nemo, ONLY:   ze0     => wrk_3d_5 , ze1   => wrk_3d_6
+      USE wrk_nemo, ONLY:   ze2     => wrk_3d_7 , ze3   => wrk_3d_8
+      !
+      INTEGER, INTENT(in) ::   kt, jnt   ! ocean time step
+      !
       INTEGER  ::   ji, jj, jk
       INTEGER  ::   irgb
       REAL(wp) ::   zchl, zxsi0r
       REAL(wp) ::   zc0 , zc1 , zc2, zc3
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zdepmoy, zetmp
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zekg, zekr, zekb
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze1 , ze2 , ze3, ze0
       !!---------------------------------------------------------------------
 
+      IF(  wrk_in_use(2, 1,2)   .OR.   wrk_in_use(3, 2,3,4,5,6,7,8)   ) THEN
+         CALL ctl_stop('p4z_opt: requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
 
       !     Initialisation of variables used to compute PAR
       !     -----------------------------------------------
-      ze1 (:,:,jpk) = 0.e0
-      ze2 (:,:,jpk) = 0.e0
-      ze3 (:,:,jpk) = 0.e0
+      ze1 (:,:,jpk) = 0._wp
+      ze2 (:,:,jpk) = 0._wp
+      ze3 (:,:,jpk) = 0._wp
 
       !                                        !* attenuation coef. function of Chlorophyll and wavelength (Red-Green-Blue)
@@ -203,6 +210,5 @@
 !CDIR NOVERRCHK
             DO ji = 1, jpi
-               IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) &
-       &           emoy(ji,jj,jk) = zetmp(ji,jj) / ( zdepmoy(ji,jj) + rtrn )
+               IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) )   emoy(ji,jj,jk) = zetmp(ji,jj) / ( zdepmoy(ji,jj) + rtrn )
             END DO
          END DO
@@ -223,5 +229,9 @@
 #endif
       !
+      IF(  wrk_not_released(2, 1,2)           .OR.   &
+           wrk_not_released(3, 2,3,4,5,6,7,8)   )   CALL ctl_stop('p4z_opt: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_opt
+
 
    SUBROUTINE p4z_opt_init
@@ -230,19 +240,30 @@
       !!
       !! ** Purpose :   Initialization of tabulated attenuation coef
-      !!
-      !!
-      !!----------------------------------------------------------------------
-
+      !!----------------------------------------------------------------------
+      !
       CALL trc_oce_rgb( xkrgb )                  ! tabulated attenuation coefficients
-!!      CALL trc_oce_rgb_read( xkrgb )               ! tabulated attenuation coefficients
       nksrp = trc_oce_ext_lev( r_si2, 0.33e2 )     ! max level of light extinction (Blue Chl=0.01)
+      !
       IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksrp, ' ref depth = ', gdepw_0(nksrp+1), ' m'
       !
-                         etot (:,:,:) = 0.e0
-                         enano(:,:,:) = 0.e0
-                         ediat(:,:,:) = 0.e0
-      IF( ln_qsr_bio )   etot3(:,:,:) = 0.e0
+                         etot (:,:,:) = 0._wp
+                         enano(:,:,:) = 0._wp
+                         ediat(:,:,:) = 0._wp
+      IF( ln_qsr_bio )   etot3(:,:,:) = 0._wp
       ! 
    END SUBROUTINE p4z_opt_init
+
+
+   INTEGER FUNCTION p4z_opt_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_opt_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( etot (jpi,jpj,jpk) , enano(jpi,jpj,jpk) ,     &
+         &      ediat(jpi,jpj,jpk) , emoy (jpi,jpj,jpk) , STAT=p4z_opt_alloc )
+         !
+      IF( p4z_opt_alloc /= 0 ) CALL ctl_warn('p4z_opt_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION p4z_opt_alloc
+
 #else
    !!----------------------------------------------------------------------
